import QtQuick 2.8
import QtQuick.Controls 2.1
import QtQuick.Dialogs 1.1

ApplicationWindow {
    id: window
    width: 600
    height: 400
    visible: true

    Rectangle
    {
        anchors.centerIn: parent
        width: 100
        height: 100
        color: "Red"

        MouseArea
        {
            anchors.fill: parent
            onClicked: drawer.open()
        }
        Text
        {
            anchors.centerIn: parent
            text: "Open Drawer"
        }
    }

    Drawer
    {
        id: drawer
        width: 0.66 * window.width
        height: window.height

        Rectangle
        {
            anchors.centerIn: parent
            width: 100
            height: 100
            color: "Blue"

            MouseArea
            {
                id: ma
                anchors.fill: parent
                onPressed:
                {
                    console.log("Drawer Button - onPressed")
                    timer.start()
                }
                onReleased: console.log("Drawer Button - onReleased")
                onClicked: console.log("Drawer Button - onClicked")
                onCanceled: console.log("Drawer Button - onCancelled")
                onPressAndHold: dialog.open()
            }
            Text
            {
                anchors.centerIn: parent
                text: "Open Dialog"
            }
        }
    }

    Timer {
        id: timer
        running: false
        repeat: false
        interval: 1000
        onTriggered: dialog.open()
    }

    Dialog
    {
        id: dialog
        visible: false
        title: "Dialog Popup"
        modal: true

        contentItem: Rectangle {
            color: "Green"
            implicitWidth: 100
            implicitHeight: 100
            Text {
                text: "Close Dialog"
                anchors.centerIn: parent
            }
            MouseArea
            {
                anchors.fill: parent
                onClicked: dialog.accept()
            }
        }
    }
}
